function isAndroid(){
	return (Ti.Platform.osname == 'android');
}

function isDisplayHighDensity(){
	return Ti.Platform.displayCaps.density=='high';
}

function isNumber(n) {
  return (n!=null) && !isNaN(parseFloat(n)) && isFinite(n);
}

function trim(str) {
	return str.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
}

function isNullOrEmpty(str) {
	return str == null || trim(str)=='';
}

function isNull(value) {
    return value==null || value == "null" || value == "<null>";
}


function adjustCtrlImg(aCtrl) {
    try {

        if (aCtrl.image!=null && aCtrl.image!='') {
            var imgName = aCtrl.image.replace('images/', 'images/android-hi/');

            if (fileExists(imgName)) {
                Ti.API.info('image adjust: ' + imgName);
                aCtrl.image = imgName;
            }
        }

        if (aCtrl.backgroundImage!=null && aCtrl.backgroundImage!='') {

            var imgBkName = aCtrl.backgroundImage.replace('images/', 'images/android-hi/');

            if (fileExists(imgBkName)) {
                Ti.API.info('bkimage adjust: ' + imgBkName);
                aCtrl.backgroundImage = imgBkName;
            }
        }
    }
    catch(e) {
        Ti.API.error('Managed error at adjustCtrlImg: ' + e.error);
    }

}


function fileExists(fileName) {
    var exists = false;
    try {
    	fileName = fileName.replace('../../', '');
    	fileName = fileName.replace('../', '');    	
    	
        var f = Titanium.Filesystem.getFile(Titanium.Filesystem.resourcesDirectory, fileName);
        
        //Ti.API.info('exists: ' + fileName + ' ' + f.exists());

        return f.exists();
    }
    catch(ex) {
        //Ti.API.error('Managed error at fileExists: ' + ex.error);
    }
    
    return exists;
}


function adjustImagesResolution(ctrl) {
	
    if (isAndroid() && isDisplayHighDensity()) {

        adjustCtrlImg(ctrl);

		//Ti.API.info('ctrl ' + ctrl + ' childs: ' + ctrl.children.length);

        for (var i=0; i < ctrl.children.length; i++) {

            var aCtrl = ctrl.children[i];

            adjustImagesResolution(aCtrl);
        }
    }    
}

function adjustImagesResolutionForRows(rows) {
	
    if (isAndroid() && isDisplayHighDensity()) {
        try {
            if (rows!=null) {
            	Ti.API.info('table here!');
                
                for (var j=0; j<rows.length; j++) {
                	adjustCtrlImg(rows[j]);                    
                    adjustImagesResolution(rows[j]);
                }
            }
        }
        catch(e) {
            Ti.API.error('Managed error at adjustImagesResolutionForRows: ' + e.error);
        }

    }
}