function getDBWithRelativePath(relPath) {

    return Titanium.Database.install(relPath + 'database/rfld.sqlite','rfld');
}

function getDB() {
	return getDBWithRelativePath('../');    
}

function getIndicatorStatus(device, indicator) {
    var status = null;

    try {
        var db = getDB();

        var rows = db.execute('SELECT * FROM device_status WHERE device = ? AND indicator = ?', device, indicator);

        if (rows.isValidRow()) {
            status = rows.fieldByName('status');
        }

        // close database
        rows.close();
        db.close();

    }
    catch(ex) {
        Ti.API.error('Managed dbError on getIndicatorStatus ' + ex);
    }
    return status;
}


function getAllIndicatorsStatus(device) {
    var data = [];

    try {
        var db = getDB();

        var rows = db.execute('SELECT * FROM device_status WHERE device = ?', device);

        while (rows.isValidRow()) {
            var record = {indicator:rows.fieldByName('indicator'), status:rows.fieldByName('status')};
            data.push(record);
            rows.next();
        }

        // close database
        rows.close();
        db.close();

    }
    catch(ex) {
        Ti.API.error('Managed dbError on getAllIndicatorsStatus ' + ex);
    }
    return data;
}

function setIndicatorStatus(device, indicator, status) {
	
    try {
        var db = getDB();
		//Ti.API.info('set indicator status ' + device + ',' + indicator + ',' + status);        
        db.execute('UPDATE device_status SET status = ? WHERE device = ? AND indicator = ?', status, device, indicator);
        
        db.close();
    }
    catch(ex) {
        Ti.API.error('Managed dbError on setIndicatorStatus ' + ex);
    }
}

//SELECT status_desc.* FROM device_status,status_desc WHERE device_status.device = 'l3x' and device_status.device = status_desc.device AND device_status.indicator = status_desc.indicator AND device_status.status = status_desc.status

function getAllIndicatorsStatusDescription(device) {
    var data = [];

    try {
        var db = getDB();

        var rows = db.execute('SELECT status_desc.* FROM device_status,status_desc WHERE device_status.device = ? and device_status.device = status_desc.device AND device_status.indicator = status_desc.indicator AND device_status.status = status_desc.status', device);

        while (rows.isValidRow()) {
            var record = {
            	indicator:rows.fieldByName('indicator'), 
            	status:rows.fieldByName('status'),
            	desc:rows.fieldByName('description'),
            	action:rows.fieldByName('action')};
            data.push(record);
            rows.next();
        }

        // close database
        rows.close();
        db.close();

    }
    catch(ex) {
        Ti.API.error('Managed dbError on getAllIndicatorsStatusDescription ' + ex);
    }
    return data;
}

function getIndicatorStatusDescription(device, indicator, status) {
    var record = null;

    try {
        var db = getDB();

        var rows = db.execute('SELECT status_desc.* FROM status_desc WHERE status_desc.device = ? AND status_desc.indicator = ? AND status_desc.status = ?', device, indicator, status);

        if (rows.isValidRow()) {
            record = {
            	indicator:rows.fieldByName('indicator'), 
            	status:rows.fieldByName('status'),
            	desc:rows.fieldByName('description'),
            	action:rows.fieldByName('action')};
        }

        // close database
        rows.close();
        db.close();

    }
    catch(ex) {
        Ti.API.error('Managed dbError on getIndicatorStatusDescription ' + ex);
    }
    return record;
}

//SELECT status FROM status_desc WHERE device = 'l3x' and indicator = 'ok'

function getIndicatorStatuses(device, indicator) {
    var data = [];

    try {
        var db = getDB();

        var rows = db.execute('SELECT status FROM status_desc WHERE device = ? and indicator = ?', device, indicator);

        while (rows.isValidRow()) {
            var record = {status:rows.fieldByName('status')};
            data.push(record);
            rows.next();
        }

        // close database
        rows.close();
        db.close();

    }
    catch(ex) {
        Ti.API.error('Managed dbError on getIndicatorStatuses ' + ex);
    }
    return data;
}

//SELECT status_summ.*,device_status.status,status_desc.description,status_desc.action FROM status_summ INNER JOIN device_status ON device_status.device = status_summ.device AND device_status.indicator = status_summ.indicator INNER JOIN status_desc ON status_desc.device = status_summ.device AND status_desc.indicator = status_summ.indicator AND status_desc.status = device_status.status WHERE status_summ.device = 'l3x'

function getStatusSummary(device) {
    var data = [];

    try {
        var db = getDB();

        var rows = db.execute('SELECT status_summ.*,device_status.status,status_desc.description,status_desc.action FROM status_summ INNER JOIN device_status ON device_status.device = status_summ.device AND device_status.indicator = status_summ.indicator INNER JOIN status_desc ON status_desc.device = status_summ.device AND status_desc.indicator = status_summ.indicator AND status_desc.status = device_status.status WHERE status_summ.device = ?', device);


        while (rows.isValidRow()) {
            var record = {
            	title:rows.fieldByName('title'), 
            	indicator:rows.fieldByName('indicator'), 
            	indicatorName:rows.fieldByName('indicator_name'), 
            	status:rows.fieldByName('status'),
            	desc:rows.fieldByName('description'),
            	action:rows.fieldByName('action')};
            data.push(record);
            rows.next();
        }

        // close database
        rows.close();
        db.close();

    }
    catch(ex) {
        Ti.API.error('Managed dbError on getStatusSummary ' + ex);
    }
    return data;
}

 