function createDeviceInfoArray(){
	
	var devicesInfo = [];
	
	devicesInfo['l2x'] = {title:'CompactLogix L2x',image:'../images/device-l2x.png', width:320, height:367,
		indicators:[
			// controller
			{id:'run', left:(isAndroid() ? 236 : 236), top:(isAndroid() ? 46 : 46), ori:0},
			{id:'force', left:236, top:53},
			{id:'batt', left:236, top:61},
			{id:'io', left:282, top:46},
			{id:'ok', left:282, top:53},
			// module
			{id:'ms', left:218, top:158},
			// network
			{id:'ns', left:235, top:183, vertical:true},
			// link
			{id:'lnk', left:235, top:219, vertical:true},
			// rs232
			{id:'ch0', left:271, top:314},
			{id:'dch0', left:282, top:61}
			],
		map:[
			{x1:16, y1:41, x2:125, y2:81, component:'controller'},
			{x1:202, y1:40, x2:249, y2:73, component:'controller'},
			{x1:248, y1:40, x2:295, y2:59, component:'controller'},
			{x1:16, y1:94, x2:122, y2:134, component:'module'},
			{x1:194, y1:83, x2:290, y2:141, component:'module'},
			{x1:194, y1:140, x2:230, y2:166, component:'module'},
			{x1:16, y1:152, x2:125, y2:191, component:'network'},
			{x1:228, y1:179, x2:280, y2:199, component:'network'},
			{x1:16, y1:204, x2:125, y2:244, component:'link'},
			{x1:228, y1:210, x2:280, y2:230, component:'link'},
			{x1:16, y1:290, x2:125, y2:332, component:'rs232'},
			{x1:200, y1:281, x2:266, y2:334, component:'rs232'},
			{x1:267, y1:308, x2:297, y2:334, component:'rs232'},
			{x1:252, y1:60, x2:294, y2:72, component:'rs232'}
			]
	};
	
	devicesInfo['l3x'] = {title:'CompactLogix L3x',image:'../images/device-l3x.png',width:320,height:367,
		indicators:[
			// controller
			{id:'run', left:220, top:40},
			{id:'force', left:220, top:49},
			{id:'batt', left:220, top:57},
			{id:'io', left:266, top:40},
			{id:'ok', left:266, top:49},
			// module
			{id:'ms', left:184, top:150},
			// ethernet
			{id:'ns', left:200, top:150},
			{id:'lnk', left:184, top:165},
			// compact flash
			{id:'cf', left:261, top:160},
			// rs232
			{id:'ch0', left:262, top:320},
			{id:'dch0', left:266, top:57}
			],
		map:[
			{x1:15, y1:38, x2:123, y2:75, component:'controller'},
			{x1:189, y1:33, x2:236, y2:67, component:'controller'},
			{x1:235, y1:33, x2:281, y2:53, component:'controller'},
			{x1:15, y1:89, x2:123, y2:126, component:'module'},
			{x1:163, y1:81, x2:253, y2:134, component:'module'},
			{x1:162, y1:134, x2:197, y2:157, component:'module'},
			{x1:15, y1:154, x2:123, y2:192, component:'ethernet'},
			{x1:162, y1:161, x2:230, y2:232, component:'ethernet'},
			{x1:199, y1:145, x2:230, y2:162, component:'ethernet'},
			{x1:15, y1:216, x2:123, y2:255, component:'cf'},
			{x1:239, y1:149, x2:289, y2:281, component:'cf'},
			{x1:15, y1:307, x2:123, y2:346, component:'rs232'},
			{x1:162, y1:240, x2:230, y2:340, component:'rs232'},
			{x1:230, y1:312, x2:274, y2:340, component:'rs232'},
			{x1:237, y1:55, x2:281, y2:67, component:'rs232'}
			]
	};
	
	devicesInfo['l4x'] = {title:'CompactLogix L4x',image:'../images/device-l4x.png',width:320,height:367,
		indicators:[
			// controller
			{id:'run', left:180, top:45},
			{id:'force', left:180, top:57},
			{id:'mem', left:180, top:68},
			{id:'io', left:222, top:45},
			{id:'pwr', left:265, top:45},
			{id:'iopwr', left:265, top:68},
			{id:'ok', left:222, top:84},
			// compact flash
			{id:'cf', left:180, top:84},
			// rs232
			{id:'ch0', left:222, top:57},
			{id:'dch0', left:222, top:68}
			],
		map:[
			{x1:14, y1:43, x2:124, y2:80, component:'controller'},
			{x1:172, y1:38, x2:212, y2:78, component:'controller'},
			{x1:212, y1:38, x2:302, y2:53, component:'controller'},
			{x1:256, y1:53, x2:302, y2:91, component:'controller'},
			{x1:214, y1:80, x2:256, y2:91, component:'controller'},
			{x1:14, y1:105, x2:124, y2:144, component:'cf'},
			{x1:172, y1:80, x2:213, y2:90, component:'cf'},
			{x1:14, y1:171, x2:124, y2:210, component:'rs232'},
			{x1:214, y1:53, x2:255, y2:76, component:'rs232'}
			]
	};
	
	return devicesInfo;
}

function setupDeviceManager() {

    try {
        var myNamespace = {};
		
		myNamespace.dInfo = null;

        myNamespace.getDeviceInfo = function() {
            return myNamespace.dInfo;
        };

        myNamespace.setDeviceInfo = function(arr) {
            myNamespace.dInfo=arr;
        };

        Ti.App.DeviceManagerNamespace = myNamespace;
        
        Ti.App.DeviceManagerNamespace.setDeviceInfo(createDeviceInfoArray());

    }
    catch(ex) {
        Ti.API.info("Managed error at setupDeviceManager " + ex);
    }
}