
function createLedView(status, left, top, type, vertical) {

	var imgLed;
	

	if (vertical == true) {
		imgLed = createLedViewVertical(status, left, top, type);
	} else {
		imgLed = createLedViewNormal(status, left, top, type);
	}
	
    return imgLed;
}

function createLedViewNormal(status, left, top, type) {

	var imgLed;
	
	var width;
	var height;

    switch (type) {
        case 0: // device (small)
			width = 8;
			height = 4;
            break;
        case 1: // component 
			width = 22;
			height = 11;
            break;
        case 2: // status summary / indicator
			width = 19;
			height = 10;
            break;
	}

	
    switch (status) {
        case 'off':
			imgLed = Titanium.UI.createImageView({
				image:'../images/led-off-lg.png',
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
            break;
        case 'sgn':
			imgLed = Titanium.UI.createImageView({
				image:'../images/led-green-lg.png',
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
            break;
        case 'fgn':
        	var images = [];
			images.push('../images/led-green-lg.png');
			images.push('../images/led-off-lg.png');
			imgLed = Titanium.UI.createImageView({
				images:images,
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
			// listen for load event (when all images are loaded)
		    imgLed.addEventListener('load', function() {
				imgLed.start();
		    });
            break;
        case 'srd':
			imgLed = Titanium.UI.createImageView({
				image:'../images/led-red-lg.png',
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
            break;
        case 'frd':
        	var images = [];
			images.push('../images/led-red-lg.png');
			images.push('../images/led-off-lg.png');
			imgLed = Titanium.UI.createImageView({
				images:images,
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
			// listen for load event (when all images are loaded)
		    imgLed.addEventListener('load', function() {
				imgLed.start();
		    });
		    break;
        case 'sam':
			imgLed = Titanium.UI.createImageView({
				image:'../images/led-amber-lg.png',
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
            break;
        case 'fam':
        	var images = [];
			images.push('../images/led-amber-lg.png');
			images.push('../images/led-off-lg.png');
			imgLed = Titanium.UI.createImageView({
				images:images,
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
			// listen for load event (when all images are loaded)
		    imgLed.addEventListener('load', function() {
				imgLed.start();
		    });
		    break;
        case 'frg':
        	var images = [];
			images.push('../images/led-red-lg.png');
			images.push('../images/led-green-lg.png');
			imgLed = Titanium.UI.createImageView({
				images:images,
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
			// listen for load event (when all images are loaded)
		    imgLed.addEventListener('load', function() {
				imgLed.start();
		    });
		    break;
    }

	/*
	if (vertical == true) {
		imgLed.transform = Ti.UI.create2DMatrix().rotate(90);
	}
	*/

    return imgLed;
}

function createLedViewVertical(status, left, top, type) {

	var imgLed;
	
	var width;
	var height;

    switch (type) {
        case 0: // device (small)
			width = 4;
			height = 8;
            break;
        case 1: // component 
			width = 11;
			height = 22;
            break;
        case 2: // status summary / indicator
			width = 10;
			height = 19;
            break;
	}

	
    switch (status) {
        case 'off':
			imgLed = Titanium.UI.createImageView({
				image:'../images/led-off-90.png',
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
            break;
        case 'sgn':
			imgLed = Titanium.UI.createImageView({
				image:'../images/led-green-90.png',
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
            break;
        case 'fgn':
        	var images = [];
			images.push('../images/led-green-90.png');
			images.push('../images/led-off-90.png');
			imgLed = Titanium.UI.createImageView({
				images:images,
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
			// listen for load event (when all images are loaded)
		    imgLed.addEventListener('load', function() {
				imgLed.start();
		    });
            break;
        case 'srd':
			imgLed = Titanium.UI.createImageView({
				image:'../images/led-red-90.png',
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
            break;
        case 'frd':
        	var images = [];
			images.push('../images/led-red-90.png');
			images.push('../images/led-off-90.png');
			imgLed = Titanium.UI.createImageView({
				images:images,
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
			// listen for load event (when all images are loaded)
		    imgLed.addEventListener('load', function() {
				imgLed.start();
		    });
		    break;
        case 'sam':
			imgLed = Titanium.UI.createImageView({
				image:'../images/led-amber-90.png',
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
            break;
        case 'fam':
        	var images = [];
			images.push('../images/led-amber-90.png');
			images.push('../images/led-off-90.png');
			imgLed = Titanium.UI.createImageView({
				images:images,
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
			// listen for load event (when all images are loaded)
		    imgLed.addEventListener('load', function() {
				imgLed.start();
		    });
		    break;
        case 'frg':
        	var images = [];
			images.push('../images/led-red-90.png');
			images.push('../images/led-green-90.png');
			imgLed = Titanium.UI.createImageView({
				images:images,
				duration:500,
				repeatCount:0,
				top:top,
				left:left,
				width:width,
				height:height
			});
			// listen for load event (when all images are loaded)
		    imgLed.addEventListener('load', function() {
				imgLed.start();
		    });
		    break;
    }

    return imgLed;
}

function createLedViewSmall(status, left, top, vertical) {
    imgLed = createLedView(status, left, top, 0, vertical);
    return imgLed;
}
