Titanium.include('common/common_funcs.js');
Titanium.include('common/deviceManager.js');
Titanium.include('common/indicatorStatus.js');
Titanium.include('common/leds.js');

var win = Titanium.UI.currentWindow;


var component = Ti.UI.currentWindow.component;  
var device = Ti.UI.currentWindow.device;  

var componentsInfo = Ti.App.ComponentsManagerNamespace.getCompsInfo();

var ci = componentsInfo[device+'-'+component];
var map = ci.map;

win.barColor='#d4d4d4';

var lblWinTtl = Titanium.UI.createLabel ({
	color:'#000',
	text: 'Indicators',
	height:25,
    top:10,
	textAlign:'center',
	font:{fontSize:20, fontWeight:'bold'}
	
});

win.titleControl = lblWinTtl;


var btnBack = Titanium.UI.createButton({
	title:'Components',
	color:'#666',
	font:{fontFamily:'Helvetica', fontSize:14, fontWeight:'bold'},
	backgroundImage:'../images/btn-components.png',
	height:32,
	width:101
});

win.setLeftNavButton(btnBack);


var sv = Ti.UI.createScrollView({
    contentWidth:Titanium.Platform.displayCaps.platformWidth,
	contentHeight:'auto',
    top:0,
    showVerticalScrollIndicator:true,
    showHorizontalScrollIndicator:false
});

var lbl1 = Titanium.UI.createLabel({
    id:'lblClass',
    text:ci.title,
    font: {
		fontWeight: 'bold',
		fontSize: 18
	},	
	top:10,
	width:289,
	height:50,
    left: 18,
    color:'#000'
});

sv.add(lbl1);

var lbl2 = Titanium.UI.createLabel({
    id:'lblClass',
    text:'Select a light to view or change its status',
	font:{fontSize:12},
	top:40,
	width:289,
	height:50,
    left: 18,
    color:'#444'
});

sv.add(lbl2);

var imgView = Titanium.UI.createImageView({
	backgroundImage:ci.image,
	top:100,
	left:(320-ci.width)/2,
	width:ci.width,
	height:ci.height
	//touchEnabled:false
});

sv.add(imgView);

win.add(sv);

Titanium.include('common/common_funcs.js');


/*----------FUNCTIONS------------------------------------------------------------------------*/

var viewInfo = null;

var imgLedArray = [];


function openIndicatorWindow(device, id, name, status) {
	var win = Titanium.UI.createWindow({  
	   	url: 'indicator.js',
	   	//title:'Indicators',
	    device:device,
	    id:id,
	    name:name,
	    status:status
	});
		
	Ti.UI.currentTab.open(win);
}

function createIndicator(indicator) {
	var status = getIndicatorStatus(device, indicator.id);
	var vertical = (indicator.vertical != null);
	var imgLed = createLedView(status, indicator.left+imgView.left, indicator.top+imgView.top, 1, vertical);
	imgLed.device = device;
	imgLed.id = indicator.id;
	imgLed.name = indicator.name;
	imgLed.status = status;
	
    imgLed.addEventListener('click', function(e) {
		openIndicatorWindow(device, e.source.id, e.source.name, e.source.status);
    });


	imgLedArray[indicator.id] = imgLed;
	
	return imgLed;
}

function loadIndicators() {
	for (var i=0; i<ci.indicators.length; i++)
	{
		imgLed = createIndicator(ci.indicators[i]);
		sv.add(imgLed);		
	}
}

function checkIndicators() {

	Ti.API.info('checkindicators on component');

	// remove indicator info
	if (viewInfo != null) { 
		if (isAndroid()) {
			viewInfo.hide();
		}
		sv.remove(viewInfo);
	}

	for (var i=0; i<ci.indicators.length; i++)
	{
		var status = getIndicatorStatus(device, ci.indicators[i].id);
		var indicatorStatus = imgLedArray[ci.indicators[i].id].status;
		if (status != indicatorStatus)
		{
			//updateIndicators();
			updateIndicator(i);
			
			// show indicator info
			viewInfo = createIndicatorInfo(device, ci.indicators[i].id, status, ci.indicators[i].name);
			sv.add(viewInfo);
			
			break;
		}
	}
}

/*
function updateIndicators() {
	Ti.API.info('updateIndicators');
	for (var i=0; i<ci.indicators.length; i++)
	{
		if (isAndroid()) { 
			imgLedArray[ci.indicators[i].id].hide();
		}
		sv.remove(imgLedArray[ci.indicators[i].id]);			
		sv.add(createIndicator(ci.indicators[i]));
	}
}
*/

function updateIndicator(indicator) {
	Ti.API.info('updateIndicator ' + indicator);
	sv.remove(imgLedArray[ci.indicators[indicator].id]);			
	sv.add(createIndicator(ci.indicators[indicator]));
}

function startAnimation(ctrl) {
	
    for (var i=0; i < ctrl.children.length; i++) {

        var aCtrl = ctrl.children[i];
        if (aCtrl.images!=null && aCtrl.images!='') {
        	aCtrl.stop();
        }
    }
    for (var i=0; i < ctrl.children.length; i++) {

        var aCtrl = ctrl.children[i];
        if (aCtrl.images!=null && aCtrl.images!='') {
        	aCtrl.start();
        }
    }
}



loadIndicators();


function createIndicatorInfo(device, indicator, status, name) {

	ind = getIndicatorStatusDescription(device, indicator, status);

	var view = Titanium.UI.createView({
	   width:Titanium.Platform.displayCaps.platformWidth,
	   height:'auto',
	   top:imgView.height+120
	});
	
	var top = 0;

	var lblTitle = Titanium.UI.createLabel({
	    text:name + ' Indicator',
	    font: {
			fontWeight:'bold',
			fontSize:18
		},	
		top:top,
		width:289,
		height:30,
	    left:18,
	    color:'#000'
	});
	view.add(lblTitle);
	
	top+=lblTitle.height;

	var imgLed3d = Titanium.UI.createImageView({
		image:'../images/led-3d.png',
		top:top+5,
		left:18,
		width:23,
		height:13
	});
	view.add(imgLed3d);

	var imgLed = createLedView(ind.status, imgLed3d.left+2, imgLed3d.top+2, 2);
	view.add(imgLed);
	
	var lblStatusDesc = Ti.UI.createLabel({
		color:'#000',
	    font: {
			fontWeight:'bold',
			fontSize:14
		},
		left:45,
		top:top+2,
		height:18,
		width:200,
		text:indicatorStatus[ind.status]
	});
	view.add(lblStatusDesc);
	
	var lblDesc = Ti.UI.createLabel({
		color:'#444',
		font:{fontSize:14},
		left:18,
		top:top+20,
		height:isAndroid() ? 50 : 'auto',
		width:250,
		text:ind.desc
	});
	view.add(lblDesc);

	top+=lblDesc.height+35;
	
	if (ind.action != null)
	{
		var lblActionTitle = Titanium.UI.createLabel({
		    text:'Take this action:',
		    font: {
				fontWeight:'bold',
				fontSize:14
			},	
			top:top,
			width:200,
			height:20,
		    left:18,
		    color:'#000'
		});
		view.add(lblActionTitle);
		
		var lblAction = Ti.UI.createLabel({
			color:'#444',
			font:{fontSize:14},
			left:18,
			top:top+16,
			height:isAndroid() ? 50 : 'auto',
			width:250,
			text:ind.action
		});
		view.add(lblAction);
		
		top+=lblAction.height+30;
	}

	return view;
}

/*----------EVENTS---------------------------------------------------------------------------*/

imgView.addEventListener('click', function(e)
{
	//Ti.API.info('click (' + e.x + ',' + e.y + ')');

	for (var i=0; i<map.length; i++)
	{
		if ((e.x > map[i].x1) && (e.y > map[i].y1) && (e.x < map[i].x2) && (e.y < map[i].y2))
		{
			//Ti.API.info('click on indicator: ' + map[i].id);
			
			var status = getIndicatorStatus(device, map[i].id);
			
			openIndicatorWindow(device, map[i].id, map[i].name, status);
			
			break;
		}		 
	}

});

win.addEventListener('focus', function(e)
{
	Ti.API.info('** focus');
	checkIndicators();
	
	startAnimation(sv);
});

win.addEventListener('blur', function(e)
{
	Ti.API.info('** blur');
    if (isAndroid()) {
    	Ti.API.info('** fire event checkindicators');
        Ti.App.fireEvent('checkindicators');
    }
});


// iOS
btnBack.addEventListener('click', function(){
    win.close();
});


win.addEventListener('android:back', function() {
    Ti.API.info('android back (component)');
    win.close();
});

adjustImagesResolution(win);