Titanium.include('common/common_funcs.js');
Titanium.include('common/devicesInfo.js');
Titanium.include('common/deviceManager.js');
Titanium.include('common/leds.js');


var win = Titanium.UI.currentWindow;

win.barColor='#d4d4d4';

win.backgroundColor = '#dedede';

var lblWinTtl = Titanium.UI.createLabel ({
	color:'#000',
	text: 'Select Component',
	height:25,
    top:10,
	textAlign:'center',
	font:{fontSize:20, fontWeight:'bold'}
	
});

win.titleControl = lblWinTtl;

var device = Ti.UI.currentWindow.device;

var devicesInfo = Ti.App.DeviceManagerNamespace.getDeviceInfo();
var di = devicesInfo[device];
var map = di.map;



var imgView = Titanium.UI.createImageView({
	backgroundImage:di.image,
	width:di.width,
	height:di.height,
	top:0
});

win.add(imgView);

var actInd = Titanium.UI.createActivityIndicator();


/*----------FUNCTIONS------------------------------------------------------------------------*/

var imgLedArray = [];

function createIndicator(indicator) {
	var status = getIndicatorStatus(device, indicator.id);
	var vertical = (indicator.vertical != null);
	var imgLed = createLedViewSmall(status, indicator.left, indicator.top, vertical);
	imgLed.device = device;
	imgLed.id = indicator.id;
	imgLed.status = status;

	imgLedArray[indicator.id] = imgLed;
	
	return imgLed;
}

function loadIndicators() {
	for (var i=0; i<di.indicators.length; i++)
	{
		//Ti.API.info('indicator: ' + di.indicators[i].id);
		imgLed = createIndicator(di.indicators[i]);
		win.add(imgLed);		
	}
}

function checkIndicators() {
	
	Ti.API.info('checkIndicators');
	
	for (var i=0; i<di.indicators.length; i++)
	{
		var status = getIndicatorStatus(device, di.indicators[i].id);
		var indicatorStatus = imgLedArray[di.indicators[i].id].status;
		if (status != indicatorStatus)
		{
			//updateIndicators();
			updateIndicator(i);
		}			
	}
}

function updateIndicator(indicator) {
	Ti.API.info('updateIndicator ' + indicator);
	win.remove(imgLedArray[di.indicators[indicator].id]);			
	win.add(createIndicator(di.indicators[indicator]));
}

/*
function updateIndicators() {
	Ti.API.info('updateIndicators');
	for (var i=0; i<di.indicators.length; i++)
	{
		win.remove(imgLedArray[di.indicators[i].id]);			
		win.add(createIndicator(di.indicators[i]));
	}
}
*/


function removeIndicators() {
	Ti.API.info('removeIndicators');
	for (var i=0; i<di.indicators.length; i++)
	{
		win.remove(imgLedArray[di.indicators[i].id]);			
	}
}

function startAnimation(ctrl) {
	
    for (var i=0; i < ctrl.children.length; i++) {

        var aCtrl = ctrl.children[i];
        if (aCtrl.images!=null && aCtrl.images!='') {
        	//Ti.API.info('stop imageview ' + i);
        	aCtrl.stop();
        }
    }
    for (var i=0; i < ctrl.children.length; i++) {

        var aCtrl = ctrl.children[i];
        if (aCtrl.images!=null && aCtrl.images!='') {
        	//Ti.API.info('start imageview ' + i);
        	aCtrl.start();
        }
    }
}

loadIndicators();


/*----------EVENTS---------------------------------------------------------------------------*/

imgView.addEventListener('click', function(e)
{
	//Ti.API.info('click (' + e.x + ',' + e.y + ')');

	for (var i=0; i<map.length; i++)
	{
		Ti.API.info('search ' + i);
		if ((e.x > map[i].x1) && (e.y > map[i].y1) && (e.x < map[i].x2) && (e.y < map[i].y2))
		{
			Ti.API.info('click on component: ' + map[i].component);
			
			var win1 = Titanium.UI.createWindow({  
			   	url: 'component.js',
			    backgroundColor:'#fff',
			    //title: 'Indicators',
			    device:device,
			    component:map[i].component
			});    		
				
			Ti.UI.currentTab.open(win1); 
			break;
		}		 
	}

});

win.addEventListener('focus', function(e)
{
	Ti.API.info('* focus');
	checkIndicators();
});

Ti.App.addEventListener('checkindicators', function(data) 
{ 
	Ti.API.info('* checkindicators');
	checkIndicators();
});

Ti.App.addEventListener('setdevice', function(data) 
{ 
	Ti.API.info('* setdevice'); 
	Ti.API.info('device: ' + data.device);
	
	/*	
	removeIndicators();
		
	device = data.device;
	di = devicesInfo[device];
	map = di.map;
	imgView.backgroundImage = di.image;
		
	loadIndicators();
	*/
	if (isAndroid()) {
		actInd.message = 'Loading...';
	} else {
		win.setRightNavButton(actInd);
	}
	
	actInd.show();
		
	removeIndicators();
		
	device = data.device;
	di = devicesInfo[device];
	map = di.map;
	imgView.backgroundImage = di.image;
		
	loadIndicators();

	actInd.hide();
	if (!isAndroid()) {
		win.setRightNavButton(null);
	}

});

win.addEventListener('android:back', function() {
    Ti.API.info('android back (device)');
    win.close();
});

adjustImagesResolution(win);
