Titanium.include('common/common_funcs.js');

var win = Titanium.UI.currentWindow;

var imgTtl = Titanium.UI.createImageView({
	backgroundImage:'../images/home-ttl.png',
	width:231, 
	height:54,
	left:45,
	top:28
});

var lblSelect = Titanium.UI.createLabel ({
	text:'Select your device:',
	font:{fontFamily:'Helvetica', fontSize:20, fontWeight:'bold'},
	color:'#000',
	width:200,
	height:30,
	left:10,
	top:imgTtl.top + imgTtl.height + 43
});

var data = [
	{title:'CompactLogix L2x', hasChild:true, color:'#000', device:'l2x'},
	{title:'CompactLogix L3x', hasChild:true, color:'#000', device:'l3x'},
	{title:'CompactLogix L4x', hasChild:true, color:'#000', device:'l4x'}
];

var tableview = Titanium.UI.createTableView({
	data:data,
	top:lblSelect.height + lblSelect.top + 10,
	height:isAndroid() ? 148 : 129,
	rowHeight:43,
	scrollable:false,
	borderWidth:1,
	borderColor:'#ababab',
	width:320,
	backgroundColor:'#fff'
});


tableview.addEventListener('click', function(e)
{
	var index = e.index;
	var section = e.section;
	var row = e.row;
	var rowdata = e.rowData;

	if (win.initNavigation || !isAndroid()) {
    	Ti.API.info('init navigation');
		var win1 = Titanium.UI.createWindow({  
		   	url:'navigation.js',
		    device:e.rowData.device
		});
		
		win1.open();
		
		if (isAndroid()) {
            win.closeOnBack = false;

            backView.hide();

            win.backgroundImage = '../images/default.png';
            
            adjustCtrlImg(win);
        }
        
	} else {
    	Ti.API.info('set active tab');
    	Ti.API.info('** fire event setdevice');
        Ti.App.fireEvent('setdevice', {device:e.rowData.device});
        Titanium.UI.currentTabGroup.setActiveTab(1);               
    }
        
});

var imgLogo = Titanium.UI.createImageView({
	backgroundImage:'../images/logo.png',
	width:166,
	height:45,
	bottom:21, 
	right: 25
	
});

var backView = Titanium.UI.createView({
	backgroundImage: '../images/home-bg.png'
});

backView.add(imgTtl);
backView.add(lblSelect);
backView.add(tableview);
backView.add(imgLogo);

win.add(backView);

/*----------EVENTS---------------------------------------------------------------------------*/

win.addEventListener('android:back', function() {
    Ti.API.info('android back (homy)');
    //win.close();
    
	
    if (win.closeOnBack) {

        Ti.API.info('clooose');
        try {
            if (win.onClose!=null) {
                win.onClose();
            }
            else {
                win.close();
            }

            var activity =   Ti.Android.currentActivity;
            activity.finish();
        }
        catch(e) {
        }
    }
    else {

        var win3 = Titanium.UI.createWindow({
            url:'views/home.js',
            initNavigation:true,
            navBarHidden:true,
            fullscreen:false,
            backgroundColor:'#fff',
            exitOnClose:true,
            closeOnBack:true,
            onClose: function() {
                Ti.API.info('winclooose');
                win.close();
                if (win.onClose!=null) {
                    win.onClose();
                }
            }

        });

        win3.open({ animated : false});

    }
	
});


adjustImagesResolution(win);