Titanium.include('common/deviceManager.js');
Titanium.include('common/indicatorStatus.js');
Titanium.include('common/leds.js');
Titanium.include('common/common_funcs.js');

var win = Titanium.UI.currentWindow;

win.backgroundColor='#eee';

win.barColor='#d4d4d4';

var lblWinTtl = Titanium.UI.createLabel ({
	color:'#000',
	text: 'Indicators',
	width:150,
	height:25,
    top:10,
	textAlign:'center',
	font:{fontSize:20, fontWeight:'bold'}
	
});

win.titleControl = lblWinTtl;

var btnBack = Titanium.UI.createButton({
	title:'Back',
	color:'#666',
	font:{fontFamily:'Helvetica', fontSize:14, fontWeight:'bold'},
	backgroundImage:'../images/btn-back.png',
	height:32,
	width:52
});

win.setLeftNavButton(btnBack);


var device = Ti.UI.currentWindow.device;  
var id = Ti.UI.currentWindow.id;  
var name = Ti.UI.currentWindow.name;
var status = Ti.UI.currentWindow.status;


var lbl1 = Titanium.UI.createLabel({
    id:'lblClass',
    text:name+' Indicator',
    font: {
		fontWeight:'bold',
		fontSize:18
	},	
	top:10,
	width:289,
	height:30,
    left:18,
    color:'#000'
});

win.add(lbl1);

//
// create table view
//
var tableView = Titanium.UI.createTableView({
	backgroundColor:'white',
	scrollable:false,
	rowHeight:44,
	top:44,
    width:Titanium.Platform.displayCaps.platformWidth,
    height:220
});


win.add(tableView);


Titanium.include('common/common_funcs.js');

/*----------FUNCTIONS------------------------------------------------------------------------*/

var indexSet = 0;


function getTableData(){
    var data = [];
    
    var is = getIndicatorStatuses(device, id);
    
	for (var i=0; i<is.length; i++)
    {
        var row = Ti.UI.createTableViewRow();

		row.selectedBackgroundColor = '#fff';
		row.height = 44;
		
		if (is[i].status == status)
		{
			indexSet = i;
		}
	
		var imgCheck = Titanium.UI.createImageView({
			backgroundImage:'../images/check.png',
			top:8,
			left:12,
			width:23,
			height:23,
			visible:(is[i].status == status)
		});
		row.add(imgCheck);
		
		var imgLed3d = Titanium.UI.createImageView({
			image:'../images/led-3d.png',
			top:15,
			left:43,
			width:23,
			height:13
		});
		row.add(imgLed3d);
	
		var imgLed = createLedView(is[i].status, imgLed3d.left+2, imgLed3d.top+2, 2);
		row.add(imgLed);
	
		var lblDesc = Ti.UI.createLabel({
			color:'#000',
			font:{fontSize:16,fontWeight:'bold'},
			left:74,
			top:8,
			height:25,
			width:200,
			text:indicatorStatus[is[i].status]
		});
		row.add(lblDesc);
	
		row.status = is[i].status;
                
        data.push(row);
    }
	
	adjustImagesResolutionForRows(data);
    
    return data;	
	
}



tableView.data = getTableData();


/*---------EVENTS---------------------------------------------------------------------------*/

btnBack.addEventListener('click', function(){
    win.close();
});


tableView.addEventListener('click', function(e)
{
	//Ti.API.info('table view row clicked - status ' + e.row.status);
	
	tableView.data[0].rows[indexSet].children[0].visible = false;
	e.rowData.children[0].visible = true;
	
	status = e.row.status;	
	indexSet = e.index;
	
	setIndicatorStatus(device, id, status);

	win.close();
});



adjustImagesResolution(win);