Titanium.include('common/common_funcs.js');
Titanium.include('common/deviceManager.js');
Titanium.include('common/indicatorStatus.js');
Titanium.include('common/leds.js');

var win = Titanium.UI.currentWindow;

win.backgroundColor='#eee';

win.barColor='#d4d4d4';

var lblWinTtl = Titanium.UI.createLabel ({
	color:'#000',
	text: 'Status Summary',
	height:25,
    top:10,
	textAlign:'center',
	font:{fontSize:20, fontWeight:'bold'}
	
});

win.titleControl = lblWinTtl;

var actInd = Titanium.UI.createActivityIndicator();

var device = Ti.UI.currentWindow.device;  



/*----------FUNCTIONS------------------------------------------------------------------------*/

var devicesDesc = [];

devicesDesc['l2x'] = 'CompactLogix L2x';
devicesDesc['l3x'] = 'CompactLogix L3x';
devicesDesc['l4x'] = 'CompactLogix L4x';


var sv = null;

function createContent() {
	
	sv = Ti.UI.createScrollView({
	    contentWidth:Titanium.Platform.displayCaps.platformWidth,
		contentHeight:'auto',
	    top:0,
	    showVerticalScrollIndicator:true,
	    showHorizontalScrollIndicator:false,
	    visible:false
	});
	
	win.add(sv);
	
	var lbl1 = Titanium.UI.createLabel({
	    id:'lblClass',
	    text:devicesDesc[device],
	    font: {
			fontWeight:'bold',
			fontSize:18
		},	
		top:10,
		width:289,
		height:30,
	    left:18,
	    color:'#000'
	});
	
	sv.add(lbl1);
	
	createSummaryContent();
}

function createSummaryContent() {
    var top = 40;
    
    var summ = getStatusSummary(device);
    
	for (var i=0; i<summ.length; i++)
    {

		if (summ[i].title != '')
		{
			var lblTitle = Titanium.UI.createLabel({
			    text:summ[i].title,
			    font: {
					fontWeight:'bold',
					fontSize:18
				},	
				top:top,
				width:289,
				height:30,
			    left:18,
			    color:'#000'
			});
			sv.add(lblTitle);
			
			top += lblTitle.height;
		}
		
		if (summ[i].indicatorName != '')
		{
			var lblIndName = Titanium.UI.createLabel({
			    text:summ[i].indicatorName,
			    font: {
					fontWeight:'bold',
					fontSize:14
				},	
				top:top,
				width:289,
				height:16,
			    left:18,
			    color:'#444'
			});
			sv.add(lblIndName);
			
			top+=lblIndName.height;
		}

		var imgLed3d = Titanium.UI.createImageView({
			image:'../images/led-3d.png',
			top:top+5,
			left:18,
			width:23,
			height:13
		});
		sv.add(imgLed3d);
			
		var imgLed = createLedView(summ[i].status, imgLed3d.left+2, imgLed3d.top+2, 2);
		sv.add(imgLed);
		
		var lblStatusDesc = Ti.UI.createLabel({
			color:'#444',
			font:{fontSize:13},
			left:45,
			top:top+2,
			height:18,
			width:200,
			text:indicatorStatus[summ[i].status]
		});
		sv.add(lblStatusDesc);
		
		top += lblStatusDesc.height;
		
		var lblDesc = Ti.UI.createLabel({
			color:'#444',
			font:{fontSize:13},
			left:45,
			top:top+2,
			height:'auto',
			width:250,
			text:summ[i].desc
		});
		sv.add(lblDesc);
		
		top += lblDesc.size.height;
		//Ti.API.info('*** height:' + lblDesc.size.height);
	
		if (summ[i].action != null)
		{
			top += 10;
			
			var lblActionTitle = Titanium.UI.createLabel({
			    text:'Take this action:',
			    font: {
					fontWeight:'bold',
					fontSize:14
				},	
				top:top,
				width:200,
				height:16,
			    left:45,
			    color:'#444'
			});
			sv.add(lblActionTitle);
			
			top+=lblActionTitle.height+2;
			
			var lblAction = Ti.UI.createLabel({
				color:'#444',
				font:{fontSize:13},
				left:45,
				top:top,
				height:'auto',
				width:250,
				text:summ[i].action
			});
			
			sv.add(lblAction);
			
			top += lblAction.size.height;
			//Ti.API.info('*** height:' + lblAction.size.height);
			
		}
		top += 35;
    }
    
}


/*----------EVENTS---------------------------------------------------------------------------*/

win.addEventListener('focus', function(e)
{
	Ti.API.info('*** focus');
	if (isAndroid()) {
		actInd.message = 'Loading...';
	} else {
		win.setRightNavButton(actInd);
	}
	
	actInd.show();
		
	Ti.API.info('createContent');

	createContent();	
	sv.show();
	
	actInd.hide();
	if (!isAndroid()) {
		win.setRightNavButton(null);
	}
});	

win.addEventListener('blur', function(e)
{
	Ti.API.info('*** blur');
	win.remove(sv);
});

Ti.App.addEventListener('setdevice', function(data) 
{ 
	Ti.API.info('*** setdevice');
	Ti.API.info('device: ' + data.device);
	device = data.device;
});

win.addEventListener('android:back', function() {
    Ti.API.info('android back (status)');
    win.close();
});

adjustImagesResolution(win);